﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WarmlyLocomotive
{
    internal class DrawningWarmlyLocomotive : DrawningLocomotive
    {
        public DrawningWarmlyLocomotive(int speed, float weight, Color bodyColor, Color dopColor, bool pipe, bool fuelCompartment, bool warmlyLines): base(speed, weight, bodyColor, 210, 120)
        {
            Locomotive = new EntityWarmlyLocomotive(speed, weight, bodyColor, dopColor, pipe, fuelCompartment, warmlyLines);
        }
        public override void DrawTransport(Graphics g)
        {
            if(Locomotive is not EntityWarmlyLocomotive warmlyLocomotive)
            {
                return;
            }
            Pen pen = new(Color.Black);
            Brush dopBrush = new SolidBrush(warmlyLocomotive.DopColor);
            if (warmlyLocomotive.Pipe)
            {
                g.FillRectangle(dopBrush, _startPosX + 125, _startPosY + 5, 35, 10);
                g.FillRectangle(dopBrush, _startPosX + 130, _startPosY, 25, 5);
                g.DrawRectangle(pen, _startPosX + 125, _startPosY + 5, 35, 10);
                g.DrawRectangle(pen, _startPosX + 130, _startPosY, 25, 5);
            }
            if (warmlyLocomotive.FuelCompartment)
            {
                g.FillRectangle(dopBrush, _startPosX + 90, _startPosY + 85, 50, 25);
                g.DrawRectangle(pen, _startPosX + 90, _startPosY + 85, 50, 25);
                g.FillEllipse(new SolidBrush(Color.Black), _startPosX + 115, _startPosY + 100, 5, 5);
            }
            _startPosY += 15;
            base.DrawTransport(g);
            _startPosY -= 15;
            if (warmlyLocomotive.WarmlyLines)
            {
                g.FillRectangle(dopBrush, _startPosX + 180, _startPosY + 60, 30, 5);
                g.FillRectangle(dopBrush, _startPosX + 180, _startPosY + 80, 30, 5);
            }
        }
    }
}
