﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.NetworkInformation;
using System.Text;
using System.Threading.Tasks;

namespace WarmlyLocomotive
{
    internal class EntityWarmlyLocomotive : EntityLocomotive
    {
        /// <summary>
        /// Дополнительный цвет
        /// </summary>
        public Color DopColor { get; set; }
        /// <summary>
        /// Признак наличия трубы
        /// </summary>
        public bool Pipe { get; private set; }
        /// <summary>
        /// Признак наличия отсека под топливо
        /// </summary>
        public bool FuelCompartment { get; private set; }
        /// <summary>
        /// Признак наличия полос на кузове
        /// </summary>
        public bool WarmlyLines { get; private set; }
        public EntityWarmlyLocomotive(int speed, float weight, Color bodyColor, Color dopColor, bool pipe, bool fuelCompartment, bool warmlyLines) :
            base(speed, weight, bodyColor)
        {
            DopColor = dopColor;
            Pipe = pipe;
            FuelCompartment = fuelCompartment;
            WarmlyLines = warmlyLines;
        }
    }
}
